%ext kdr
%version 1.13

#################################
#Change data files		#
#################################

%patchfile $1CB20 egahead.kdr 	#New graphics
%patchfile $2308E STORY.KDR	#New story
%patchfile $29C46 MAPDICT.KDR	#Neutralize MAPDICT
%patchfile $1FA50 MAPHEAD.KDR	#New maps
%patchfile $1FC46 KeenD.tli	#New tile properties
%patchfile $22880 AUDIOHED.KDR	#Audio header
%patchfile $2A042 MAPDICT.KDR	#Audio dictionary


#################################
#Map stuff			#
#################################

#Tiles used in DONE sign:
%patch $4B59 $59     #Tile that when under level icon triggers DONE sign
%patch $4B53 $00 $00 #Clears 1,1 and 2,1 of level icon block
%patch $4B75 $50 $00 #1,1
%patch $4B82 $7A $00 #2,1
%patch $4B67 $58 $00 #2,2


#################################
#Ending story			#
#################################

#Adjustments
%patch $596C $EF $07 #Text read from (2nd window)
%patch $59A6 $B9 $08 #Text read from (3rd window)
%patch $591C $20 $00 #Window width (30 chars)
%patch $595B $20 $00 #Window width (30 chars)
%patch $5995 $20 $00 #Window width (30 chars)

%patch $24128 "As the gigantic elf slowly" $0A
              "collapses into a swirl of" $0A
              "snowflakes, Keen picks up the" $0A
              "shattered remains of an" $0A
              "ornament and muses on one of the" $0A
              "strangest battles he has yet" $0A
              "endured. Wearily he looks to" $0A
              "where Santa is held prisoner." $0A $0A

%patch $2420C "But Santa is gone!" $0A $0A

              "All that remains is a note" $0A
              " scribbled hastily in coal" $0A
              "dust..." $0A $00

%patch $2425F "'Thanks.'" $0A $0A

               "'Oh, and I know when you are" $0A
               "sleeping, I know when you're" $0A
               "awake...'" $0A $0A

               "Keen immediately feels a" $0A
               "familiar sleepy feeling..." $0A $0A

               "And wakes up in his room, in" $0A
               "his bed. Christmas is saved yet" $0A
               "again!" $0A $00

%patch $24329 "Over a healthy breakfast, (the" $0A
              "president having banned all" $0A
              "candy after choking on a" $0A
              "pretzel.) Keen rushes to unwrap" $0A
              "his presents. And what does he" $0A
              "find under the tree?" $0A $0A

%patch $243D2 "'THE (UN)OFFICIAL Keen 7-9" $0A
              "TRILOGY! This isn't even out in" $0A
              "stores yet! Best christmas ever!'" $0A $0A

              "Merry Christmas to you, whatever" $0A
              "time of year you're playing!" $0A $00


#################################
#Texts				#
#################################

%patch $24115 "Bombs in level!" $00

#Paused (Needs fixing for level names)
%patch $4529 $61 $06
%patch $240D1 "PAUSED" $00

#Load level (Needs fixing for level names)
%patch $4573 $68 $06 #When loading saved game
%patch $5DB5 $68 $06 #When loading level
%patch $240D8 "Loading" $00

#Can't defeat window: (Uses old start screen space!)
%patch $6A60 $0F $00 #Window height (6 chars)
%patch $6A64 $1C $00 #Window width (26 chars)
%patch $6A75 $27 $52 #Text read from:

%patch $28C97 "The door refuses to open"	$0A $0A

              "A mocking voice says:"		$0A
              "'Nice try kiddo! But" $0A
              "nothing can harm me except" $0A
              "my specially built bomb" $0A
              "baubles scattered across" $0A
              "the land! And I'm- wait..." $0A $0A

              "I shouldn't have told you that...'" $0A $00


#################################
#Patch a new start screen	#
#################################

#Screen:
#%patchfile $124B1 "KDREAMS.DAT"	#Screen code
#%patchfile $32AD0 "KDREAMS.TXT"	#Sceen text

#The 'Ready press a key text:
%patch $13852 $18 $00 #V position, lines
%patch $13856 $1A $00 #V position, lines
%patch $1384B $AB     #Color
%patch $1384E $87 $51 #Text loc
%patch $28BF7 "   Ready: Press a key!   " $00


#################################
#Level names patch		#
#################################

#Set pointers to level names:
%patch $23E48 $5A $05 $66 $05 $72 $05 $80 $05 $8E $05 $9A $05 $AA $05 $BC $05
              $CD $05 $DF $05 $F1 $05 $FB $05 $0B $06 $1A $06 $53 $06 $2A $06
              $3C $06 $4D $06

#Level name:
%patch $23FCA "Pseudotopia" $00
%patch $23FD6 "Xmas Forest" $00
%patch $23FE2 "The Igloo" $00
%patch $23FF0 "Sledding Hill" $00
              "Cake Canyon" $00
              " Cookie Cliffs " $00
              "Gingerbread House" $00
              "Ice Skating Pond" $00
              "Winter Wonderland" $00
              "Midnight Clearing" $00
              "Coal Mine" $00
              "Santa's Cottage" $00
              "Peach Pie Pass" $00
              "Crystal Caverns" $00
              "Bad Elf's Chamber" $00
              "Bad Elf's Castle" $00
              "Title" $00
              "Hidden Hills" $00

%patch $24571 "You didn't make it past"
%patch $24589 "Try again"

#K1n9_Duk3 fix: moved the string so it doesn't overwrite other data
%patch $2455D "Exit to Pseudotopia" $00
%patch $5A4A $0AEDW




#########################################
#Enemy sprite patches			#
#########################################


#################################
#Pea -> Nap cookie		#
#################################

#Pea spawns using spare wilted flower frames
%patch $9191  $E6 $17 #Wilted flower 5&6

#Change wilted flower to be useful enemy
%patch $25272 $04 $18		#Goto 6
%patch $25290 $46 $1B		#Spawn cookie
%patch $25266 $00 $00 $00 $00	#Remove behavior from
%patch $25284 $00 $00 $00 $00	#Frames so don't 'unwilt'
%patch $25256 $59 $01 $59 $01	#Change anims and speeds
%patch $25260 $40 $01
%patch $25274 $5A $01 $5A $01
%patch $2527E $14 $00


#################################
#PeaPod -> Tank			#
#################################

#Use three animations with four frames to walk
%patch $25D18 $62 $01 $5F $01
%patch $25D36 $63 $01 $60 $01
%patch $25D54 $64 $01 $61 $01
%patch $25D72 $63 $01 $60 $01 #This is a repat of #2

#Make Peapod a rolling tank
%patch $25D90 $5D $01 $5B $01	#Change anims
%patch $25DAE $5E $01 $5C $01
%patch $25D9A $05 $00		#Double anim speed
%patch $25DB8 $05 $00
%patch $25D9C $40 $00		#Havle walking speed (Smoother roll)
%patch $25DBA $40 $00
%patch $25DCA $20 $23		#Change to 2 frames

#Peapod spit aniamtions
%patch $25E08 $66 $01 $65 $01
%patch $25E26 $66 $01 $65 $01

#Set cache start less four (Not needed for tank or pea)
%patch $23E8E $59 $01		#Pea and Peapod cache start

#Change spitting conditions
%patch $92E6 $0E $FF $90 $90 #Condition 1: Spit in any direction
%patch $92F0 $18 $00 $7D     #Condition 2: Spit FAR more often
%patch $92F5 $7C $3E $04 $7D #Condition 3: Produce a max of 10 peas per pod


#################################
#Wilted flower -> Iceblock	#
#################################

#Vanish after 4th frame: (Frees two frames at $25260)
%patch $25254 $00 $00

#Change animation speed
%patch $251E8 $22 $00
%patch $25206 $22 $00
%patch $25224 $12 $00
%patch $25242 $12 $00

#K1n9_Duk3 fix: make FlowerThink end after calling ProjectileThink
#(the code SHOULD never initiate the recover phase anyway, but just in case...)
%patch $8060 $5E $5D $CB


#################################
#Carrot -> Reindeer		#
#################################

#Change 4:4-frame run to 4:2 (1-2-1-2)
%patch $255F2 $05 $01 $07 $01
%patch $25610 $06 $01 $08 $01
%patch $2562E $05 $01 $07 $01
%patch $2564C $06 $01 $08 $01
%patch $2566A $09 $01 $0A $01 #(Alter Jump to fit)

#Slow animation speed
%patch $255FC $0A $00
%patch $2561A $0A $00
%patch $25638 $0A $00
%patch $25656 $0A $00

#Increase running speed
%patch $255FE $F0
%patch $2561C $F0
%patch $2563A $F0
%patch $25658 $F0


#################################
#Tater trooper -> Eskimo	#
#################################

#Reduce walking to two frames: (Frees two actions at $257D0)
%patch $257B2 $08 $1D       	#Walk 2 (Goto 1)

#Change animations to fit new bitspace:
%patch $25778 $1F $01 $1A $01 	#Tater walk
%patch $25796 $20 $01 $1B $01 	#Tater walk
%patch $257F0 $21 $01 $1C $01   #Tater stab
%patch $2580E $22 $01 $1D $01	#Tater stab
%patch $2582C $23 $01 $1E $01	#Tater stab

#Shrink cache:
%patch $23E82 $1A $01


#################################
#Star (Grape)			#
#################################

#Add extra animation frame for rising star:
%patch $2573C $19 $01 $19 $01
%patch $25746 $1E $00		#Animation speed

#Expand cache:
%patch $23EAC $19 $01		#Grape cache end


#################################
#Chips -> candle		#
#################################

#CANDLE BUG: Gets stuck in tunnels 2 tiles high.

#Slow down the candle's hopping movement
%patch $25890 $14
%patch $258AE $14
%patch $258CC $14
%patch $258EA $14

#When candle 'charges' it just slides on the ground:
%patch $2591A $8E $1E



#################################
#Broccoli -> penguin		#
#################################

#Change walking frame:
%patch $2548A $F2 $00 $FA $00

#Slow down animation:
%patch $2543A $0E $00
%patch $25458 $0E $00
%patch $25476 $0E $00
%patch $25494 $0E $00

#Change running speed to compensate:
%patch $2543C $F0 $00
%patch $2545A $F0 $00
%patch $25478 $F0 $00
%patch $25496 $F0 $00

#Dash ahead when slapping
%patch $254B4 $60 $00
%patch $254D2 $60 $00
%patch $254F0 $60 $00
%patch $2550E $40 $00
%patch $2552C $C0 $FF
%patch $2554A $C0 $FF
%patch $25568 $C0 $FF

#Change slap animations
%patch $254A8 $F4 $00 $FC $00
%patch $254C6 $F5 $00 $FD $00
%patch $254E4 $F6 $00 $FE $00
%patch $25502 $F7 $00 $FF $00
%patch $25520 $F8 $00 $00 $01
%patch $2553E $F4 $00 $FC $00
%patch $2555C $F5 $00 $FD $00


#################################
#Melon -> snowman		#
#################################

#Snowballs use Keen's snowball anim
%patch $25AC0 $3E $01 $3D $01
%patch $25ADE $3E $01 $3D $01

#Snowman has extra throwing frame, slow throwing speed
%patch $25A2A $3B $01 $3C $01
%patch $25A16 $C0 $00       #Animation speed
%patch $25A52 $0A $00       #Animation speed
%patch $25A52 $0A $00       #Animation speed


#################################
#Apple -> elf			#
#################################

#Apple has only 2 walking frames
%patch $25C08 $5E $21 #Walk 2


############################################
# Disable Checking For "/DETOUR" Parameter #
############################################

%patch $3BD1 $EB


##############################
# Custom Startup Text Screen #
##############################

# replace US_TextScreen contents with B800 screen code and data:
%patch $124B1
	$B8 $B800w		#	mov	ax, 0B800h
	$8E $C0			#	mov	es, ax
	$33 $FF			#	xor	di, di
	$8C $C8			#	mov	ax, cs
	$8E $D8			#	mov	ds, ax
	$BE $052Ew		#	mov	si, 052Eh
	$B9 $07D0w		#	mov	cx, 2000
	$F3 $A5			#	rep	movsw
	$8C $D0			#	mov	ax, ss
	$8E $D8			#	mov	ds, ax
	$5F			#	pop	di
	$5E			#	pop	si
	$8B $E5			#	mov	sp, bp
	$5D			#	pop	bp
	$CB			#	retf

# insert the screen data, overwriting the rest of the old US_TextScreen code
# Note: screen data must be headerless (exactly 4000 bytes)

%patchfile $124CE INTROSCN.KDR


#######################
# Disable Exit Screen #
#######################

# don't try to execute "LOADSCN.EXE ENDSCN.SCN LAST.SHL"
%patch $3A02 $33 $C9 $EB $F4


####################################################################
# Customized Screen Update Code For Keen Dreams (EGA) version 1.13 #
####################################################################

# turn /NOSB check into /JERK check:
%patch $280F9 "JERK" $00

# always skip SoundBlaster detection:
%patch $11D22 $EB

# replace old VW_SetScreen code (doesn't all fit, though!)
%patch $E03B
	$55			#	push	bp
	$8B $EC			#	mov	bp, sp
	$BA $03DAw		#	mov	dx, 3DAh
	$FA			#	cli
				#@l1:
	$EC			#	in	al, dx
	$A8 $01			#	test	al, 1
	$74 $FB			#	jz	@l1
				#@l2:
	$EC			#	in	al, dx
	$A8 $01			#	test	al, 1
	$75 $FB			#	jnz	@l2
	$8B $4E $06		#	mov	cx, [bp+arg_start]
	$BA $03D4w		#	mov	dx, 3D4h
	$B0 $0C			#	mov	al, 0Ch
	$EE			#	out	dx, al
	$42			#	inc	dx
	$8A $C5			#	mov	al, ch
	$EE			#	out	dx, al
	$4A			#	dec	dx
	$B0 $0D			#	mov	al, 0Dh
	$EE			#	out	dx, al
	$8A $C1			#	mov	al, cl
	$42			#	inc	dx
	$EE			#	out	dx, al
	$8B $0E $E590w		#	mov	cx, fixjerky
	$E3 $03			#	jcxz	@l3
	$E8 $F872w		#	call	WaitVBL
				#@l3:
	$BA $03C0w		#	mov	dx, 3C0h
	$B0 $33			#	mov	al, 33h
	$EE			#	out	dx, al
	$EB $00			#	jmp	$
	$8A $46 $08		#	mov	al, [bp+arg_pan]
	$EE			#	out	dx, al
	$E9 $F87Ew		#	jmp	rest_of_VW_SetScreen

# replace VW_Plot with new code (VW_Plot now uses VW_Vlin to plot one pixel)
%patch $D8C6
	$55			#	push	bp
	$8B $EC			#	mov	bp, sp
	$FF $76 $0A		#	push	[bp+10]	;color
	$FF $76 $06		#	push	[bp+6]	;x
	$8B $46 $08		#	mov	ax, [bp+8]	;y
	$50			#	push	ax	;y
	$50			#	push	ax	;y
	$0E			#	push	cs
	$E8 $003Dw		#	call	VW_Vlin
	$8B $E5			#	mov	sp, bp
	$5D			#	pop	bp
	$CB			#	retf

#WaitVBL:
	$8B $1E $E818w		#	mov	bx, word ptr TimeCount
	$BA $03DAw		#	mov	dx, 3DAh
				#@wait:	
	$FB			#	sti
	$EB $00			#	jmp	short $
	$FA			#	cli
	$EC			#	in	al, dx
	$A8 $08			#	test	al, 8
	$75 $0A			#	jnz	@done
	$A1 $E818w		#	mov	ax, word ptr TimeCount
	$2B $C3			#	sub	ax, bx
	$3D $0001w		#	cmp	ax, 1
	$76 $ED			#	jbe	@wait
				#@done:
	$C3			#	retn

#rest_of_VW_SetScreen:
	$0B $C9			#	or	cx, cx
	$75 $03			#	jnz	@l5
	$E8 $FFDEw		#	call	WaitVBL
				#@l5:
	$FB			#	sti
	$5D			#	pop	bp
	$CB			#	retf

# This leaves 20 bytes unused at $D901



#################################################################
# Make "MM_GETNEWBLOCK: No free blocks!" Errors Far Less Likely #
#################################################################

# add a helper function, based on MML_ClearBlock from KEEN 4-6:
# (this is inserted in MM_Startup, disabling the useless EMS/XMS startup code)
%patch $AA6F
	$EB $38			#	jmp	....
	$90			#	nop
	$1E			#	push	ds
	$C5 $1E $8F00w		#	lds	bx, mmhead
	$EB $1A			#	jmp	loopcheck
				#loopdo:
	$C5 $5F $08		#	lds	bx, [bx+8]
	$F6 $47 $04 $80		#	test	[bx+4], 80h
	$75 $11			#	jnz	loopcheck
	$F6 $47 $04 $03		#	test	[bx+4], 3
	$74 $0B			#	jz	loopcheck
	$8B $47 $06		#	mov	ax, [bx+6]
	$1F			#	pop	ds
	$50			#	push	ax
	$0E			#	push	cs
	$E8 $030Dw		#	call	near ptr MM_FreePtr
	$58			#	pop	ax
	$CB			#	retf
				#loopcheck:
	$8B $47 $08		#	mov	ax, [bx+8]
	$0B $47 $0A		#	or	ax, [bx+10]
	$75 $DE			#	jnz	loopdo
	$1F			#	pop	ds
	$B8 $26D1w		#	mov	ax, offset error_nofreeblocks
	$50			#	push	ax
	$9A $037B0205rl		#	call	Quit()
	$58			#	pop	ax
	$CB			#	retf


# call my MML_ClearBlock in MM_GetPtr:
%patch $AB82
	$A1 $8F04w		#	mov	ax, mmfree
	$0B $06 $8F06w		#	or	ax, mmfree+2
	$75 $08			#	jnz	okay
	$9A $0A7D02A2rl		#	call	MML_ClearBlock
	$90 $90 $90		#	nop nop nop
				#okay:
	$A1 $8F04w		#	mov	ax, mmfree
	$A3 $8EFCw		#	mov	mmnew, ax
	$A1 $8F06w		#	mov	ax, mmfree+2
	$A3 $8EFEw		#	mov	mmnew+2, ax

# This also frees up MML_CheckForEMS (77 bytes at $A7DF)


########################################################
# Free Tile And Sprite Graphics Before Loading A Level #
########################################################

# new code (replaces MML_CheckForEMS):
%patch $A7DF
	$CB			#	retf	(this is MML_CheckForEMS)
				#FreeUpMemory:
	$56			#	push	si
	$BE $909Cw		#	mov	si, offset grsegs+...
				#l1:
	$83 $3C $00		#	cmp	word ptr [si], 0
	$74 $0D			#	jz	next
	$B8 $0003w		#	mov	ax, 3
	$50			#	push	ax
	$56			#	push	si
	$9A $0A7D0696rl		#	call	MM_SetPurge
	$83 $C4 $04		#	add	sp, 4
				#next:
	$46			#	inc	si
	$46			#	inc	si
	$81 $FE $A79Cw		#	cmp	si, offset grsegs+...
	$72 $E6			#	jb	l1
	$5E			#	pop	si
	$EA $0B2D0F5Drl		#	jmp	CA_CacheMap

# make SetupGameLevel call the new code instead of CA_CacheMap:
%patch $4BD7
	$9A $0A7D0010rl		#	call	FreeUpMemory



########################
# Fix Text Drawing Bug #
########################

# Avoid crashing when trying to draw characters that don't exist in the font:
%patch $27B44 $0865w


######################################################
# Fix Potential Memory Sorting Issue In LoadLIBShape #
######################################################

%patch $9C44 $FE
%patch $9C4C $FE
%patch $9C6D $FE
%patch $9EAE $FE
%patch $9EB4 $FE


###############################
# Fix Savegame Difficulty Bug #
###############################

%patch $44A9
	$83 $3E $4716w $00	#	cmp	restartgame, 0
	$75 $12			#	jnz	newgame
	$83 $3E $E892w $00	#	cmp	loadedgame, 0
	$75 $03			#	jnz	loaded
	$E9 $FEF0w		#	jmp	innerloop
				#loaded:
	$A1 $7128w		#	mov	ax, gamestate.difficulty
	$A3 $4716w		#	mov	restartgame, ax
	$EB $04			#	jmp	startgame
				#newgame:
	$0E			#	push	cs
	$E8 $F73Dw		#	call	near ptr NewGame
				#startgame:
	$8D $46 $EA		#	lea	ax, [bp+var_FileShape1]
	$50			#	push	ax
	$9A $09590007rl		#	call	FreeShape
	$58			#	pop	ax
	$9A $044D1829rl		#	call	GameLoop
	$E9 $FE9Fw		#	jmp	outerloop


##################
# Savegame Patch #
##################

# This patch forces the game to save and load the entire object array, keeping
# any pointers to other objects in the array intact after loading a saved game.
# Keen Dreams stores some pointers in the object's user variables (temp1 to
# temp4), which could cause issues when a game was saved while Keen was
# sleeping (i.e. the "Zzz" sprite was visible) or an enemy was in the process
# of changing from the flower state back to its regular state (i.e. the smoke
# object was present).
#
# This obviously means the saved games will be in a slightly different format
# that is no longer compatible with the saved games created by the unpatched
# save routines. That's why this patch also changes part of the saved game's
# signature, making the incompatible saves show up as empty savegame slots.

%patch $28BE3 "r"	# change signature to avoid compatibility issues

# change SaveGame code:
%patch $3F56
	$8D $46 $FA		#	lea	ax, [bp-6]
	$50			#	push	ax
	$9A $0A7D05CErl		#	call	MM_FreePtr
	$58			#	pop	ax
				#
	$2E $C6 $06 $0509w $B9	#	mov	cs:iocall+1, offset CA_FarWrite
				#
	$BA $1DB0w		#	mov	dx, 7600 ;100 * size objtype
	$B8 $712Aw		#	mov	ax, offset objarray
	$E8 $0190w		#	call	doio
	$74 $27			#	jz	return
	$B8 $702Cw		#	mov	ax, offset objfreelist
	$E8 $0185w		#	call	wordio
	$74 $1F			#	jz	return
	$B8 $7056w		#	mov	ax, offset lastobj
	$E8 $017Dw		#	call	wordio
	$74 $17			#	jz	return
	$B8 $7028w		#	mov	ax, offset objectcount
	$E8 $0175w		#	call	wordio
	$74 $0F			#	jz	return
	$B8 $0001w		#	mov	ax, 1
	$EB $0A			#	jmp	return

# change LoadGame code:
%patch $409B
	$2E $C6 $06 $0509w $6E	#	mov	cs:iocall+1, offset CA_FarRead
				#
	$BA $1DB0w		#	mov	dx, 7600 ;100 * size objtype
	$B8 $712Aw		#	mov	ax, offset objarray
	$E8 $0055w		#	call	doio
	$74 $4A			#	jz	return
	$B8 $702Cw		#	mov	ax, offset objfreelist
	$E8 $004Aw		#	call	wordio
	$74 $42			#	jz	return
	$B8 $7056w		#	mov	ax, offset lastobj
	$E8 $0042w		#	call	wordio
	$74 $3A			#	jz	return
	$B8 $7028w		#	mov	ax, offset objectcount
	$E8 $003Aw		#	call	wordio
	$74 $32			#	jz	return
	$8B $36 $7034w		#	mov	si, player
	$EB $0D			#	jmp	objcheck
				#objloop:
	$C7 $44 $04 $0001w	#	mov	[si+objtype.needtoreact], 1
	$C7 $44 $46 $0000w	#	mov	[si+objtype.sprite], 0
	$8B $74 $48		#	mov	si, [si+objtype.next]
				#objcheck:
	$0B $F6			#	or	si, si
	$75 $EF			#	jnz	objloop
				#
	$8B $1E $7024w		#	mov	bx, scoreobj
	$C7 $47 $3E $FFFFw	#	mov	[bx+objtype.temp1], 0FFFFh
	$C7 $47 $40 $FFFFw	#	mov	[bx+objtype.temp2], 0FFFFh
	$C7 $47 $42 $FFFFw	#	mov	[bx+objtype.temp3], 0FFFFh
	$C7 $47 $44 $FFFFw	#	mov	[bx+objtype.temp4], 0FFFFh
	$B8 $0001w		#	mov	ax, 1
				#return:
	$5F			#	pop	di
	$5E			#	pop	si
	$8B $E5			#	mov	sp, bp
	$5D			#	pop	bp
	$CB			#	retf


				#wordio:	;4FCh (call with AX = offset, [bp+6] = handle)
	$BA $0002w		#	mov	dx, 2
				#
				#doio:	; 4FFh (call with AX = offset, DX = size, [bp+6] = handle)
	$31 $DB			#	xor	bx, bx
	$53			#	push	bx
	$52			#	push	dx
	$1E			#	push	ds
	$50			#	push	ax
	$FF $76 $06		#	push	[bp+6]
	$9A $0B2D006Erl		#iocall:	call	CA_FarRead ;508h
	$83 $C4 $0A		#	add	sp, 0Ah
	$0B $C0			#	or	ax, ax
	$C3			#	retn


%end